#ifdef _MSC_VER
  #ifdef _DEBUG
    // detect Memory-Leaks
    #include <crtdbg.h>
    #define _CRTDBG_MAP_ALLOC
  #endif
#endif
#ifdef _DEBUG_MEMORY_SPY
  #include <MliForMain.h>
#endif
#include "MyTestClient.h"
#include <EuException.h>
#include <iostream>
#if defined(_MSC_VER) || defined(__MINGW32__)
  #include <conio.h>
#elif defined(__GNUC__)
  #include <unistd.h>
  #include <termios.h>
  #include <stdio.h>
  #include <string.h>
  //---------------------------------------------------------------------------
  int _getche()
  {
    char            ch = 0;
    struct termios  tOld;

    fflush( stdout );
    if ( tcgetattr( 0, & tOld ) < 0 )
    {
      perror("tcgetattr");
    }
    tOld.c_lflag &= ~ICANON;
    tOld.c_lflag &= ~ECHO;
    tOld.c_cc[VMIN] = 1;
    tOld.c_cc[VTIME] = 0;
    if ( tcsetattr( 0, TCSANOW, & tOld ) < 0 )
    {
      perror("tcsetattr ICANON");
    }
    if ( read( 0, & ch, 1 ) < 0 )
    {
      perror("read");
    }
    tOld.c_lflag |= ICANON;
    tOld.c_lflag |= ECHO;
    if ( tcsetattr( 0, TCSADRAIN, & tOld ) < 0 )
    {
      perror("tcsetattr ~ICANON");
    }
    return ch;
  }
  //---------------------------------------------------------------------------
  int _kbhit( void )
  {
    static  int     ch = 0,
                    fd = 0;
    struct termios  tNew,
                    tOld;

    tcgetattr( fd, & tOld );
    memcpy( & tNew, & tOld, sizeof( tNew ) );
    tNew.c_lflag = tNew.c_lflag & ( ! ICANON );
    tNew.c_cc[VMIN] = 0;
    tNew.c_cc[VTIME] = 1;
    tcsetattr( fd, TCSANOW, & tOld );
    if ( ch != -1 ) ungetc( ch, stdin );
    return ( ( ch != -1 ) ? 1 : 0 );
  }
  //---------------------------------------------------------------------------
#endif
//-----------------------------------------------------------------------------
int main( int argc, char** argv )
{
  #ifdef _MSC_VER
    #ifdef _DEBUG
      // Display the memory leaks if any are present...
      _CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );
      // Next line with the memory address from "{ } ({56} normal block at 0x00D01C78, 10 bytes long.)".
      //_crtBreakAlloc = 1149;
    #endif
  #endif
  #ifdef _DEBUG_MEMORY_SPY
    MemSpy::activateMemoryMonitoring();
  #endif

  int             t_iErr = 0;
  MyTestClient  * t_pClient( 0 );
  char            t_Key;
  std::string     t_sClientOutput;
  char          * t_pBuffer = 0;

  try
  {
    // If servers on other computers use the IP address instead of "LOCALHOST
    t_pClient = new MyTestClient( "LOCALHOST", 12345, PF_INET, SOCK_STREAM, 0, 150, 5 );
  }
  catch( eut::ErrorNException ERR )
  {
    std::cout << "new MyTestClient Err: " << ERR.error() << std::endl;
    std::cout << "press key"; t_Key = _getche();
    return ERR.error();
  }

  std::cout << "client started!" << std::endl;
  t_iErr = t_pClient->connectServer();
  if ( ! t_iErr )
  {
    std::string     t_sIPAdress;
    unsigned int    t_uiPort(0);

    t_iErr = t_pClient->getPeerName( t_sIPAdress, t_uiPort );
    std::cout << "client ip:" << t_sIPAdress << " port:" << t_uiPort << std::endl;
    do
    {
      std::cout << "input for server or 'q' for exit:" << std::endl;
      std::cin >> t_sClientOutput;
      if ( ! t_sClientOutput.empty() )
      {
        t_pBuffer = new char[ strlen( t_sClientOutput.c_str() ) + 1 ];
        strcpy(t_pBuffer, t_sClientOutput.c_str());
        t_pBuffer[ strlen( t_sClientOutput.c_str() ) ] = '\x00';
        // The method to send (inherited from Client), could be overwritten
        // for more functionality
        t_iErr = t_pClient->send( t_pBuffer, strlen( t_sClientOutput.c_str() ) + 1 );
        // only delete if error
        if ( t_iErr )
        {
          delete[] t_pBuffer;
        }
      }
    } while ( ! t_iErr && t_sClientOutput != "q" );
  }
  else
  {
    std::cout << "connection Err: " << t_iErr << std::endl;
  }
  t_iErr = t_pClient->disconnectServer();
  t_pClient->cancel();
  delete t_pClient;
  #ifdef _DEBUG_MEMORY_SPY
    // Display memory leaks
    MemSpy::finishMemoryMonitoring( MemSpy::OUTPUT_TRACE | MemSpy::OUTPUT_CONSOLE );
  #endif
  std::cout << "press key"; t_Key = _getche();
  return 0;
}
