//-----------------------------------------------------------------------------
/*!
\file MyTestServer.cpp
\brief Source for MyTestServer.
\author Helmut Jakoby
\copyright © 2010 Helmut Jakoby
<!-- @@TermsOfLicense BEGIN -->

<b>Terms of License</b>

This file is part of the EuTcpLib module.

EuTcpLib is free software:

This library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.

<b>GNU Affero General Public License Usage</b><br>
You can redistribute it and/or modify it under the terms of the GNU Affero General Public
License as published by the Free Software Foundation; either version 3 of the
License, or (at your option) any later version. Please review the following
information to ensure the GNU Affero General Public License requirements will be
met: https://www.gnu.org/licenses/agpl-3.0.en.html .
<!-- @@TermsOfLicense END -->
Laber
*/
//-----------------------------------------------------------------------------
#include "MyTestServer.h"
#include <iostream>
//-----------------------------------------------------------------------------
#define SUPER Server
//-----------------------------------------------------------------------------
MyTestServer::MyTestServer()
: SUPER()
{
}
//-----------------------------------------------------------------------------
MyTestServer::MyTestServer( unsigned int uiPort,
                            int iAdressFamily,
                            int iSocketType,
                            int iProtocol,
                            int iSecTimeOut )
: SUPER( uiPort, iAdressFamily, iSocketType, iProtocol, iSecTimeOut )
{
}
//-----------------------------------------------------------------------------
MyTestServer::MyTestServer( unsigned int uiPort,
                            int iAdressFamily,
                            int iSocketType,
                            int iProtocol,
                            unsigned int uiDataSize,
                            int iSecTimeOut )
: SUPER( uiPort, iAdressFamily, iSocketType, iProtocol, uiDataSize, iSecTimeOut )
{
}
//-----------------------------------------------------------------------------
MyTestServer::MyTestServer( unsigned int uiPort,
                            int iAdressFamily,
                            int iSocketType,
                            int iProtocol,
                            unsigned int uiDataSize,
                            unsigned long ulMaxClients,
                            int iSecTimeOut )
: SUPER( uiPort, iAdressFamily, iSocketType, iProtocol, uiDataSize, ulMaxClients, iSecTimeOut )
{
}
//-----------------------------------------------------------------------------
MyTestServer::~MyTestServer()
{
}
//-----------------------------------------------------------------------------
void MyTestServer::processClientMessage( tcp::AbstractMessage * pTcpMessage )
{
  tcp::Message             * t_pTcpMessage = dynamic_cast<tcp::Message*>( pTcpMessage );
  tcp::ServerMessage       * t_pTcpServerMessage = dynamic_cast<tcp::ServerMessage*>( pTcpMessage );
  tcp::ServerAcceptMessage * t_pTcpServerAcceptMessage = dynamic_cast<tcp::ServerAcceptMessage*>( pTcpMessage );
  
  if ( t_pTcpServerMessage )
  {
    if ( t_pTcpServerMessage->getActionCode() < 0 )
    {
      std::cout << "server get error-msg from client[" <<  t_pTcpServerMessage->getSocket() <<"] with code [" << t_pTcpServerMessage->getActionCode() << "]" << std::endl;
    }
    else
    {
      std::cout << "server get client-msg from client[" << t_pTcpServerMessage->getSocket() << "] with code [" << t_pTcpServerMessage->getActionCode() << "]";
      if ( t_pTcpServerMessage->getRawMsgSize() )
      {
        std::cout << " - " << t_pTcpServerMessage->getRawMsgPt();
      }
      std::cout << std::endl;
    }
  }
  else if ( t_pTcpServerAcceptMessage )
  {
    std::cout << "new client:" << t_pTcpServerAcceptMessage->getSocket() << std::endl;
  }
  else if ( t_pTcpMessage )
  {
    std::cout << "Err! No message!" << std::endl;
  }
  if ( pTcpMessage ) SUPER::processClientMessage( pTcpMessage );
}
//-----------------------------------------------------------------------------
int MyTestServer::sendToAllClients( std::string strMsg )
{
  int                                                         t_iErr = 0;
  std::map< SOCKET, ServerReceiverTransmitter * >::iterator   m_ClientMapIterator;
  char                                                      * t_pchBuffer = 0;
  tcp::Message                                              * t_pTcpMessage = 0;
  
  if ( m_ClientMap.size() > 0 )
  {
    for ( m_ClientMapIterator = m_ClientMap.begin();
          m_ClientMapIterator != m_ClientMap.end();
          m_ClientMapIterator++ )
    {
      t_pchBuffer = new char[ strlen( strMsg.c_str() ) + 1 ];
      strcpy(t_pchBuffer, strMsg.c_str());
      t_pchBuffer[ strlen( strMsg.c_str() ) ] = '\x00';
      t_pTcpMessage = new tcp::Message( t_pchBuffer, strlen( strMsg.c_str() ) + 1, 0, 0, "" );
      // int acceptOrder( Message * pTcpMessage  );
      t_iErr = (*m_ClientMapIterator).second->send( t_pTcpMessage );
    }
  }
  return t_iErr;
}
//-----------------------------------------------------------------------------
void MyTestServer::insertNewClient( Server::ServerReceiverTransmitter * pNewServerReceiverTransmitter )
{
  int              t_iErr(0);
  std::string      t_sIPAdress;
  unsigned int    t_uiPort(0);
  
  SUPER::insertNewClient( pNewServerReceiverTransmitter );
  t_iErr = pNewServerReceiverTransmitter->getPeerName( t_sIPAdress, t_uiPort );
  std::cout << "new client ip:" << t_sIPAdress << " port:" << t_uiPort << " err:" << t_iErr << std::endl;

}
//-----------------------------------------------------------------------------
#undef SUPER
//-----------------------------------------------------------------------------
