//-----------------------------------------------------------------------------
/*!
\file TcpReceiver.cpp
\brief Source for Receiver.
\author Helmut Jakoby
\copyright © 2010 Helmut Jakoby
<!-- @@TermsOfLicense BEGIN -->

<b>Terms of License</b>

This file is part of the EuTcpLib module.

EuTcpLib is free software:

This library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.

<b>GNU Affero General Public License Usage</b><br>
You can redistribute it and/or modify it under the terms of the GNU Affero General Public
License as published by the Free Software Foundation; either version 3 of the
License, or (at your option) any later version. Please review the following
information to ensure the GNU Affero General Public License requirements will be
met: https://www.gnu.org/licenses/agpl-3.0.en.html .
<!-- @@TermsOfLicense END -->
*/
//-----------------------------------------------------------------------------
#include "TcpReceiver.h"
#if defined(__GNUC__) && !defined(__MINGW32__)
  #include <stdlib.h>
  #include <unistd.h>
  #define WSAENOTSOCK 10038L
  #define WSAECONNRESET 10054L
#endif
#ifdef _DEBUG
  #include <iostream>
  #include <sstream>
#endif
//-----------------------------------------------------------------------------
namespace tcp
{
  //---------------------------------------------------------------------------
  #define SUPER ReceiverTransmitter
  //---------------------------------------------------------------------------
  Receiver::Receiver()
  : SUPER(),
    m_pParentTcpMain( NULL_PTR )
  {
    #ifdef _DEBUG
      m_strDebugInfo = "tcp::Receiver";
    #endif
  }
  //---------------------------------------------------------------------------
  Receiver::Receiver( SOCKET Socket )
  : SUPER( Socket ),
    m_pParentTcpMain( NULL_PTR )
  {
    #ifdef _DEBUG
      m_strDebugInfo = "tcp::Receiver";
    #endif
  }
  //---------------------------------------------------------------------------
  Receiver::Receiver( TcpMain * pParent, SOCKET Socket )
  : SUPER( Socket ),
    m_pParentTcpMain( pParent )
  {
    #ifdef _DEBUG
      m_strDebugInfo = "tcp::Receiver";
    #endif
  }
  //---------------------------------------------------------------------------
  Receiver::~Receiver()
  {
  }
  //---------------------------------------------------------------------------
  #if defined(__GNUC__)
    // Warnung: base class 'class ReceiverTransmitter' should be explicitly initialized in the copy constructor [-Wextra]
    #pragma GCC diagnostic push
    #pragma GCC diagnostic ignored "-Wextra"
  #endif
  //---------------------------------------------------------------------------
  Receiver::Receiver( const Receiver & )
  : m_pParentTcpMain( NULL_PTR )
  {
  }
  //---------------------------------------------------------------------------
  #if defined(__GNUC__)
    // Warnung: base class 'class ReceiverTransmitter' should be explicitly initialized in the copy constructor
    #pragma GCC diagnostic pop
  #endif
  //---------------------------------------------------------------------------
  Receiver & Receiver::operator= ( const Receiver & )
  {
      return *this;
  }
  //---------------------------------------------------------------------------
  #undef SUPER
  //---------------------------------------------------------------------------
} // namespace tcp
//-----------------------------------------------------------------------------
